/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Contents of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 188 - (show annotations)
Tue Mar 16 22:00:20 2010 UTC (14 years, 1 month ago) by dpavlin
File MIME type: application/x-sh
File size: 4246 byte(s)
added boot and disable
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides: lxc-watchdog
4 # Required-Start: $remote_fs $named $network $time
5 # Required-Stop: $remote_fs $named $network
6 # Required-Start:
7 # Required-Stop:
8 # Default-Start: 2 3 4 5
9 # Default-Stop: 0 1 6
10 # Short-Description: Manage Linux Containers startup/shutdown
11 # Description: Uses clever inotify hack to monitor container's
12 # halt/reboot events watching /var/run/utmp
13 ### END INIT INFO
14
15 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 #
17 # based on Tony Risinger post to lxc-users mailing list
18 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19
20
21 which inotifywait >/dev/null || apt-get install inotify-tools
22
23
24 lxc_exists() {
25 name=$1
26
27 if [ ! -e /var/lib/lxc/$name/config ] ; then
28 echo "Usage: $0 name"
29 lxc_status
30 exit 1
31 fi
32 }
33
34
35 lxc_rootfs() {
36 grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
37 }
38
39
40 lxc_status() {
41 lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
42 on_boot=" "
43 test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"
44 echo "$name $status $on_boot $(lxc_rootfs $name)"
45 done
46 }
47
48
49 cleanup_init_scripts() {
50 rootfs=$(lxc_rootfs $1)
51
52 ls \
53 $rootfs/etc/rc?.d/*umountfs \
54 $rootfs/etc/rc?.d/*umountroot \
55 $rootfs/etc/rc?.d/*hwclock* \
56 2>/dev/null | xargs -i rm -v {}
57 }
58
59
60 setup_inittab() {
61 rootfs=$(lxc_rootfs $1)
62 remove=$2
63 add=$3
64
65 # let container respond to kill -SIGPWR
66 inittab=$rootfs/etc/inittab
67 if ! grep "$add" ${inittab} >/dev/null ; then
68 grep -v "$remove" ${inittab} > ${inittab}.new
69 echo $add >> ${inittab}.new
70 mv ${inittab}.new ${inittab}
71 echo "$inittab modified with $add"
72 fi
73 }
74
75
76 lxc_kill() {
77 name=$1
78 sig=$2
79
80 init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
81 if [ -z "$init_pid" ] ; then
82 lxc-info -n $name
83 exit 1
84 fi
85 echo "$name kill $sig $init_pid"
86 /bin/kill $sig $init_pid
87 }
88
89 lxc_stop() {
90 lxc_kill $name -SIGPWR
91 lxc-wait -n $name -s STOPPED
92 # rm -f /var/lib/lxc/${name}/on_boot
93 }
94
95
96 lxc_start() {
97 name=$1
98
99 if ! lxc-info -n $name | grep RUNNING ; then
100 echo "$name start"
101 lxc-start -n $name -o /tmp/${name}.log -d
102 lxc-wait -n $name -s RUNNING
103 lxc-info -n $name
104 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
105 fi
106 }
107
108 lxc_log() {
109 echo `date +%Y-%m-%dT%H:%M:%S` $*
110 }
111
112 lxc_watchdog() {
113 name=$1
114 rootfs=$(lxc_rootfs $1)
115
116 while true; do
117 vps_utmp=${rootfs}/var/run/utmp
118 tasks=`wc -l < /cgroup/${name}/tasks`
119 test -z "$tasks" && exit 1
120 if [ "$tasks" -eq 1 ]; then
121
122 runlevel="$(runlevel ${vps_utmp})"
123 lxc_log "$name runlevel $runlevel"
124
125 case $runlevel in
126 N*)
127 # nothing for new boot state
128 ;;
129 ??0)
130 lxc_log "$name halt"
131 lxc-stop -n "${name}"
132 lxc-wait -n ${name} -s STOPPED
133 break
134 ;;
135 ??6)
136 lxc_log "$name reboot";
137 lxc-stop -n ${name}
138 lxc-wait -n ${name} -s STOPPED
139 lxc-start -d -n ${name} -o /tmp/${name}.log
140 ;;
141 *)
142 # make sure vps is still running
143 state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
144 [ "$state" = "RUNNING" ] || break
145 ;;
146 esac
147 else
148 lxc_log "$name $tasks tasks"
149 fi
150
151 # time of 5 minutes on it JUST IN CASE...
152 inotifywait -qqt 300 ${vps_utmp}
153 done
154
155 lxc_log "$name exited"
156
157 }
158
159
160 command_on_lxc() {
161 command=$1
162 shift
163
164 echo "# $command $1"
165
166 case "$command" in
167
168 start)
169 lxc_exists $1
170 cleanup_init_scripts $1
171 setup_inittab $1 ::power "p0::powerfail:/sbin/init 0"
172 setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"
173 lxc_start $1
174 # give container 5 seconds to start more than one process
175 ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
176 ;;
177 stop|halt)
178 lxc_exists $1
179 lxc_stop $1
180 ;;
181 reload|force-reload|restart|reboot)
182 lxc_kill $1 -SIGINT
183 ;;
184 watchdog)
185 lxc_watchdog $1
186 ;;
187 boot)
188 echo $1 > /var/lib/lxc/$1/on_boot
189 ;;
190 disable)
191 echo -n > /var/lib/lxc/$1/on_boot
192 ;;
193 *)
194 echo "Usage: $0 {start|stop|restart|status}" >&2
195 exit 3
196 ;;
197
198 esac
199
200 }
201
202 command=$1
203
204 test "$command" = "status" && lxc_status && exit
205
206 if [ -z "$1" ] ; then
207 ls /var/lib/lxc/*/on_boot | while read path ; do
208 name=`echo $path | cut -d/ -f5`
209 command_on_lxc $command $name
210 done
211 else
212 shift
213 while [ ! -z "$1" ] ; do
214 command_on_lxc $command $1
215 shift
216 done
217 fi
218

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26